# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ClusterArgs', 'Cluster']

@pulumi.input_type
class ClusterArgs:
    def __init__(__self__, *,
                 connection: pulumi.Input['ConnectionArgs'],
                 name: pulumi.Input[str],
                 node_ids: pulumi.Input[Sequence[pulumi.Input[str]]],
                 chunks: Optional[pulumi.Input['ChunkConfigArgs']] = None,
                 config: Optional[pulumi.Input['ClusterConfigArgs']] = None,
                 device_class: Optional[pulumi.Input[str]] = None,
                 replicas: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a Cluster resource.
        """
        pulumi.set(__self__, "connection", connection)
        pulumi.set(__self__, "name", name)
        pulumi.set(__self__, "node_ids", node_ids)
        if chunks is not None:
            pulumi.set(__self__, "chunks", chunks)
        if config is not None:
            pulumi.set(__self__, "config", config)
        if device_class is not None:
            pulumi.set(__self__, "device_class", device_class)
        if replicas is not None:
            pulumi.set(__self__, "replicas", replicas)

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Input['ConnectionArgs']:
        return pulumi.get(self, "connection")

    @connection.setter
    def connection(self, value: pulumi.Input['ConnectionArgs']):
        pulumi.set(self, "connection", value)

    @property
    @pulumi.getter
    def name(self) -> pulumi.Input[str]:
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: pulumi.Input[str]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="nodeIds")
    def node_ids(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        return pulumi.get(self, "node_ids")

    @node_ids.setter
    def node_ids(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "node_ids", value)

    @property
    @pulumi.getter
    def chunks(self) -> Optional[pulumi.Input['ChunkConfigArgs']]:
        return pulumi.get(self, "chunks")

    @chunks.setter
    def chunks(self, value: Optional[pulumi.Input['ChunkConfigArgs']]):
        pulumi.set(self, "chunks", value)

    @property
    @pulumi.getter
    def config(self) -> Optional[pulumi.Input['ClusterConfigArgs']]:
        return pulumi.get(self, "config")

    @config.setter
    def config(self, value: Optional[pulumi.Input['ClusterConfigArgs']]):
        pulumi.set(self, "config", value)

    @property
    @pulumi.getter(name="deviceClass")
    def device_class(self) -> Optional[pulumi.Input[str]]:
        return pulumi.get(self, "device_class")

    @device_class.setter
    def device_class(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device_class", value)

    @property
    @pulumi.getter
    def replicas(self) -> Optional[pulumi.Input[int]]:
        return pulumi.get(self, "replicas")

    @replicas.setter
    def replicas(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "replicas", value)


class Cluster(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 chunks: Optional[pulumi.Input[pulumi.InputType['ChunkConfigArgs']]] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['ClusterConfigArgs']]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['ConnectionArgs']]] = None,
                 device_class: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 node_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 replicas: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Create a Cluster resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ClusterArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Create a Cluster resource with the given unique name, props, and options.
        :param str resource_name: The name of the resource.
        :param ClusterArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ClusterArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 chunks: Optional[pulumi.Input[pulumi.InputType['ChunkConfigArgs']]] = None,
                 config: Optional[pulumi.Input[pulumi.InputType['ClusterConfigArgs']]] = None,
                 connection: Optional[pulumi.Input[pulumi.InputType['ConnectionArgs']]] = None,
                 device_class: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 node_ids: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 replicas: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ClusterArgs.__new__(ClusterArgs)

            __props__.__dict__["chunks"] = chunks
            __props__.__dict__["config"] = config
            if connection is None and not opts.urn:
                raise TypeError("Missing required property 'connection'")
            __props__.__dict__["connection"] = connection
            __props__.__dict__["device_class"] = device_class
            if name is None and not opts.urn:
                raise TypeError("Missing required property 'name'")
            __props__.__dict__["name"] = name
            if node_ids is None and not opts.urn:
                raise TypeError("Missing required property 'node_ids'")
            __props__.__dict__["node_ids"] = node_ids
            __props__.__dict__["replicas"] = replicas
            __props__.__dict__["status"] = None
        super(Cluster, __self__).__init__(
            'pvecluster:index:Cluster',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None) -> 'Cluster':
        """
        Get an existing Cluster resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = ClusterArgs.__new__(ClusterArgs)

        __props__.__dict__["chunks"] = None
        __props__.__dict__["config"] = None
        __props__.__dict__["connection"] = None
        __props__.__dict__["device_class"] = None
        __props__.__dict__["name"] = None
        __props__.__dict__["node_ids"] = None
        __props__.__dict__["replicas"] = None
        __props__.__dict__["status"] = None
        return Cluster(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def chunks(self) -> pulumi.Output[Optional['outputs.ChunkConfig']]:
        return pulumi.get(self, "chunks")

    @property
    @pulumi.getter
    def config(self) -> pulumi.Output[Optional['outputs.ClusterConfig']]:
        return pulumi.get(self, "config")

    @property
    @pulumi.getter
    def connection(self) -> pulumi.Output['outputs.Connection']:
        return pulumi.get(self, "connection")

    @property
    @pulumi.getter(name="deviceClass")
    def device_class(self) -> pulumi.Output[Optional[str]]:
        return pulumi.get(self, "device_class")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="nodeIds")
    def node_ids(self) -> pulumi.Output[Sequence[str]]:
        return pulumi.get(self, "node_ids")

    @property
    @pulumi.getter
    def replicas(self) -> pulumi.Output[Optional[int]]:
        return pulumi.get(self, "replicas")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        return pulumi.get(self, "status")

